langtools/test/tools/javap/stackmap/T6271292.sh
author jjg
Wed, 05 Aug 2009 07:43:50 -0700
changeset 3547 4471bb5983d1
parent 10 06bc494ca11e
child 3768 46e043243c0e
permissions -rw-r--r--
6868553: 6867671 breaks some tests Reviewed-by: mcimadamore
Ignore whitespace changes - Everywhere: Within whitespace: At end of lines:
10
06bc494ca11e Initial load
duke
parents:
diff changeset
     1
#!/bin/sh
06bc494ca11e Initial load
duke
parents:
diff changeset
     2
06bc494ca11e Initial load
duke
parents:
diff changeset
     3
#
06bc494ca11e Initial load
duke
parents:
diff changeset
     4
# Copyright 2005-2007 Sun Microsystems, Inc.  All Rights Reserved.
06bc494ca11e Initial load
duke
parents:
diff changeset
     5
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
06bc494ca11e Initial load
duke
parents:
diff changeset
     6
#
06bc494ca11e Initial load
duke
parents:
diff changeset
     7
# This code is free software; you can redistribute it and/or modify it
06bc494ca11e Initial load
duke
parents:
diff changeset
     8
# under the terms of the GNU General Public License version 2 only, as
06bc494ca11e Initial load
duke
parents:
diff changeset
     9
# published by the Free Software Foundation.
06bc494ca11e Initial load
duke
parents:
diff changeset
    10
#
06bc494ca11e Initial load
duke
parents:
diff changeset
    11
# This code is distributed in the hope that it will be useful, but WITHOUT
06bc494ca11e Initial load
duke
parents:
diff changeset
    12
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
06bc494ca11e Initial load
duke
parents:
diff changeset
    13
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
06bc494ca11e Initial load
duke
parents:
diff changeset
    14
# version 2 for more details (a copy is included in the LICENSE file that
06bc494ca11e Initial load
duke
parents:
diff changeset
    15
# accompanied this code).
06bc494ca11e Initial load
duke
parents:
diff changeset
    16
#
06bc494ca11e Initial load
duke
parents:
diff changeset
    17
# You should have received a copy of the GNU General Public License version
06bc494ca11e Initial load
duke
parents:
diff changeset
    18
# 2 along with this work; if not, write to the Free Software Foundation,
06bc494ca11e Initial load
duke
parents:
diff changeset
    19
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
06bc494ca11e Initial load
duke
parents:
diff changeset
    20
#
06bc494ca11e Initial load
duke
parents:
diff changeset
    21
# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa Clara,
06bc494ca11e Initial load
duke
parents:
diff changeset
    22
# CA 95054 USA or visit www.sun.com if you need additional information or
06bc494ca11e Initial load
duke
parents:
diff changeset
    23
# have any questions.
06bc494ca11e Initial load
duke
parents:
diff changeset
    24
#
06bc494ca11e Initial load
duke
parents:
diff changeset
    25
06bc494ca11e Initial load
duke
parents:
diff changeset
    26
# @test
06bc494ca11e Initial load
duke
parents:
diff changeset
    27
# @bug 6271292
06bc494ca11e Initial load
duke
parents:
diff changeset
    28
# @compile T6271292.java
06bc494ca11e Initial load
duke
parents:
diff changeset
    29
# @run shell T6271292.sh
06bc494ca11e Initial load
duke
parents:
diff changeset
    30
# @summary Verify that javap prints StackMapTable attribute contents
06bc494ca11e Initial load
duke
parents:
diff changeset
    31
# @author Wei Tao
06bc494ca11e Initial load
duke
parents:
diff changeset
    32
    
06bc494ca11e Initial load
duke
parents:
diff changeset
    33
if [ "${TESTSRC}" = "" ]
06bc494ca11e Initial load
duke
parents:
diff changeset
    34
then
06bc494ca11e Initial load
duke
parents:
diff changeset
    35
  echo "TESTSRC not set.  Test cannot execute.  Failed."
06bc494ca11e Initial load
duke
parents:
diff changeset
    36
  exit 1
06bc494ca11e Initial load
duke
parents:
diff changeset
    37
fi
06bc494ca11e Initial load
duke
parents:
diff changeset
    38
printf 'TESTSRC="%s"' "${TESTSRC}" >&2 ; echo >&2
06bc494ca11e Initial load
duke
parents:
diff changeset
    39
if [ "${TESTJAVA}" = "" ]
06bc494ca11e Initial load
duke
parents:
diff changeset
    40
then
06bc494ca11e Initial load
duke
parents:
diff changeset
    41
  echo "TESTJAVA not set.  Test cannot execute.  Failed."
06bc494ca11e Initial load
duke
parents:
diff changeset
    42
  exit 1
06bc494ca11e Initial load
duke
parents:
diff changeset
    43
fi
06bc494ca11e Initial load
duke
parents:
diff changeset
    44
printf 'TESTJAVA="%s"' "${TESTJAVA}" >&2 ; echo >&2
06bc494ca11e Initial load
duke
parents:
diff changeset
    45
if [ "${TESTCLASSES}" = "" ]
06bc494ca11e Initial load
duke
parents:
diff changeset
    46
then
06bc494ca11e Initial load
duke
parents:
diff changeset
    47
  echo "TESTCLASSES not set.  Test cannot execute.  Failed."
06bc494ca11e Initial load
duke
parents:
diff changeset
    48
  exit 1
06bc494ca11e Initial load
duke
parents:
diff changeset
    49
fi
06bc494ca11e Initial load
duke
parents:
diff changeset
    50
printf 'TESTCLASSES="%s"' "${TESTCLASSES}" >&2 ; echo >&2
06bc494ca11e Initial load
duke
parents:
diff changeset
    51
printf 'CLASSPATH="%s"' "${CLASSPATH}" >&2 ; echo >&2
06bc494ca11e Initial load
duke
parents:
diff changeset
    52
06bc494ca11e Initial load
duke
parents:
diff changeset
    53
# set platform-dependent variables
06bc494ca11e Initial load
duke
parents:
diff changeset
    54
OS=`uname -s`
06bc494ca11e Initial load
duke
parents:
diff changeset
    55
case "$OS" in
06bc494ca11e Initial load
duke
parents:
diff changeset
    56
  CYGWIN* | Windows* )
06bc494ca11e Initial load
duke
parents:
diff changeset
    57
    FS="\\"
06bc494ca11e Initial load
duke
parents:
diff changeset
    58
    ;;
06bc494ca11e Initial load
duke
parents:
diff changeset
    59
  * )
06bc494ca11e Initial load
duke
parents:
diff changeset
    60
    FS="/"
06bc494ca11e Initial load
duke
parents:
diff changeset
    61
    ;;
06bc494ca11e Initial load
duke
parents:
diff changeset
    62
esac
06bc494ca11e Initial load
duke
parents:
diff changeset
    63
06bc494ca11e Initial load
duke
parents:
diff changeset
    64
JAVAPFILE=T6271292.javap
06bc494ca11e Initial load
duke
parents:
diff changeset
    65
OUTFILE=outfile
06bc494ca11e Initial load
duke
parents:
diff changeset
    66
06bc494ca11e Initial load
duke
parents:
diff changeset
    67
"${TESTJAVA}${FS}bin${FS}javap" ${TESTTOOLVMOPTS} -classpath "${TESTCLASSES}" -verbose T6271292 > "${JAVAPFILE}"
06bc494ca11e Initial load
duke
parents:
diff changeset
    68
result="$?"
06bc494ca11e Initial load
duke
parents:
diff changeset
    69
if [ "$result" -ne 0 ] 
06bc494ca11e Initial load
duke
parents:
diff changeset
    70
then
06bc494ca11e Initial load
duke
parents:
diff changeset
    71
  exit "$result"
06bc494ca11e Initial load
duke
parents:
diff changeset
    72
fi
06bc494ca11e Initial load
duke
parents:
diff changeset
    73
06bc494ca11e Initial load
duke
parents:
diff changeset
    74
grep "frame_type" "${JAVAPFILE}" > "${OUTFILE}"
06bc494ca11e Initial load
duke
parents:
diff changeset
    75
grep "offset_delta" "${JAVAPFILE}" >> "${OUTFILE}"
06bc494ca11e Initial load
duke
parents:
diff changeset
    76
grep "stack = " "${JAVAPFILE}" >> "${OUTFILE}"
06bc494ca11e Initial load
duke
parents:
diff changeset
    77
grep "locals = " "${JAVAPFILE}" >> "${OUTFILE}"
3547
4471bb5983d1 6868553: 6867671 breaks some tests
jjg
parents: 10
diff changeset
    78
diff -w "${OUTFILE}" "${TESTSRC}${FS}T6271292.out"
10
06bc494ca11e Initial load
duke
parents:
diff changeset
    79
result="$?"
06bc494ca11e Initial load
duke
parents:
diff changeset
    80
if [ "$result" -eq 0 ]
06bc494ca11e Initial load
duke
parents:
diff changeset
    81
then
06bc494ca11e Initial load
duke
parents:
diff changeset
    82
  echo "Passed"
06bc494ca11e Initial load
duke
parents:
diff changeset
    83
else
06bc494ca11e Initial load
duke
parents:
diff changeset
    84
  echo "Failed"
06bc494ca11e Initial load
duke
parents:
diff changeset
    85
fi
06bc494ca11e Initial load
duke
parents:
diff changeset
    86
exit "$result"
06bc494ca11e Initial load
duke
parents:
diff changeset
    87
06bc494ca11e Initial load
duke
parents:
diff changeset
    88